<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 The zen-cart developers                           |
// |                                                                      |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                      |
// | Portions Copyright (c) 2003 osCommerce                               |
// | This source file is subject to version 2.0 of the GPL license.       |
// +----------------------------------------------------------------------+
// | asjpayment.jp Payment Module V.1.0.1                                 |
// | includes/modules/payment/asjpayment.php                              |
// | Module created by ASJ(asjpayment.jp) - 13/02/2020                    |
// | Released under GPL                                                   |
// +----------------------------------------------------------------------+

	class asjpayment {
		var $code, $title, $description, $enabled;

// class constructor
	function __construct() {
		global $order;

		$this->code = 'asjpayment';
		$this->codeVersion = MODULE_PAYMENT_ASJPAYMENT_MODULE_VERSION;
		$this->title = MODULE_PAYMENT_ASJPAYMENT_TEXT_TITLE;
		$this->description = MODULE_PAYMENT_ASJPAYMENT_TEXT_DESCRIPTION;
		$this->explain = MODULE_PAYMENT_ASJPAYMENT_TEXT_EXPLAIN;
		$this->sort_order = MODULE_PAYMENT_ASJPAYMENT_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_ASJPAYMENT_STATUS == 'True') ? true : false);

		if ((int)MODULE_PAYMENT_ASJPAYMENT_ORDER_STATUS_ID > 0) {
			$this->order_status = MODULE_PAYMENT_ASJPAYMENT_ORDER_STATUS_ID;
		}
		if (is_object($order)) $this->update_status();
		try {
			$this->form_action_url = MODULE_PAYMENT_ASJPAYMENT_URL;
		} catch (Throwable $t) {
		// Executed only in PHP 7, will not match in PHP 5.x
		} catch (Exception $e) {
		// Executed only in PHP 5.x, will not be reached in PHP 7
		}
		$this->email_footer = MODULE_PAYMENT_ASJPAYMENT_TEXT_EMAIL_FOOTER;
	}

// class methods
	function update_status() {
		global $db, $order;

		if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_ASJPAYMENT_ZONE > 0) ) {
			$check_flag = false;
			$check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_ASJPAYMENT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
			while (!$check->EOF) {
				if ($check->fields['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check->fields['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
				$check->MoveNext();
			}
			if ($check_flag == false) {
				$this->enabled = false;
			}
		}
	}

	function javascript_validation() {
		return false;
	}

	function selection() {
		global $order;

		for ($i=1; $i<13; $i++) {
			$expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
		}
		$today = getdate();
		for ($i=$today['year']; $i < $today['year']+10; $i++) {
			$expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
		}
		$selection = array('id' => $this->code,
							'module' => $this->title,
							'fields' => array('title' => $this->explain,'field' => '')
					);
		return $selection;
	}

	function pre_confirmation_check() {
		global $current_domain;
		// Chrome時特別処理
		if(phpversion() >= '8') return false;
		$useragent = $_SERVER['HTTP_USER_AGENT'];
		if(strpos($useragent, 'Chrome/') !== false && strpos($useragent, 'Edge/') === false) {
			// セッションクッキーの設定をみて置き換えるかどうか
			$cookieopt = session_get_cookie_params();
			$re_cookie = true;
			if(strtolower($cookieopt['samesite']) === 'none' && $cookieopt['secure'] === true) {
				$re_cookie = false;
			}
			// セッションがクッキーとして発行されていたならクッキーを上書き
			if($re_cookie === true) {
				if(array_key_exists(session_name(), $_COOKIE)) {
					setcookie(session_name(), session_id(), 0, $cookieopt["path"]."; SameSite=None", $cookieopt["domain"], true, $cookieopt["httponly"]);
				}
				if(array_key_exists('cookie_test', $_COOKIE)) {
					zen_setcookie('cookie_test', 'please_accept_for_session', time()+60*60*24*30, '/; SameSite=None', (zen_not_null($current_domain) ? $current_domain : ''), true);
				}
			}
		}
		return false;
	}

	function confirmation() {
		global $HTTP_POST_VARS, $order;

		$confirmation = array('title' => $this->title ,
							'fields' => array('title' => MODULE_PAYMENT_ASJPAYMENT_TEXT_CREDIT_METHOD)
						);
		if ((PROJECT_VERSION_MAJOR . '.' . PROJECT_VERSION_MINOR) >= '1.5') {
			return false;
		} else {
			return $confirmation;
		}
	}

	function process_button() {
		global $db, $order;
		$asjpayment_job_code = MODULE_PAYMENT_ASJPAYMENT_JOB_CODE;
		$asjpayment_admin_no = MODULE_PAYMENT_ASJPAYMENT_ADMIN_NO;
		$mail = mb_convert_kana($order->customer['email_address'],"a");
		if((PROJECT_VERSION_MAJOR . '.' . PROJECT_VERSION_MINOR) >= '1.5') {
			$total = zen_round($order->info['total'], 0);
		} else {
			if( TAX_ROUND_OPTION == "raise" ){
				$total = ceil($order->info['total']);
			}else if(TAX_ROUND_OPTION == "drop"){
				$total = floor($order->info['total']);
			}else if(TAX_ROUND_OPTION == "round"){
				$total = round($order->info['total']);
			}else{
				$total = zen_round($order->info['total'], 0);
			}
		}

		$asjpayment_charge_no = 0;
		$db->Execute("insert into asjpayment_charge(n_admin, n_amount, c_mail, d_create) values('$asjpayment_admin_no', $total, '$mail' ,now())");
		$asjpayment_charge_no = $db->Insert_ID();
		$process_button_string = zen_draw_hidden_field('admin', MODULE_PAYMENT_ASJPAYMENT_ADMIN_NO) .
								zen_draw_hidden_field('amount', $total) .
								zen_draw_hidden_field('charge', $asjpayment_charge_no) .
								zen_draw_hidden_field('mail', $mail) .
								zen_draw_hidden_field('name', $order->customer['firstname'].$order->customer['lastname']) .
								zen_draw_hidden_field('utf', '1') .
								zen_draw_hidden_field('version', (PROJECT_VERSION_MAJOR . '.' . PROJECT_VERSION_MINOR).'_'.MODULE_PAYMENT_ASJPAYMENT_MODULE_VERSION);
		return $process_button_string;
	}

	function before_process() {
		return false;
	}

	function after_process() {
		global $insert_id, $order, $db;
		global $sales_id,$tranid,$refapproved,$refforwarded,$errcode,$errinfo,$errlevel,$r_code,$rec_type,$x_amount,$x_tax,$x_total,$asjpayment_cc_job_code;

		if( strlen($order->info['comments']) > 0 ){ $newline = "\n\n"; }
		else{ $newline = ""; }
		$charge_no = $_POST['charge'];
		$order->info['comments'] .= $newline . "伝票番号：" . $charge_no;
		$db->Execute("update " . TABLE_ORDERS_STATUS_HISTORY . " set comments='" . $order->info['comments'] . "' where orders_id='$insert_id'");
	}

	function output_error() {
		return false;
	}

	function get_error() {
		global $HTTP_POST_VARS,$HTTP_GET_VARS;

		if (isset($HTTP_GET_VARS['error']) && (strlen($HTTP_GET_VARS['error']) > 0)) {
			$error_message = stripslashes(urldecode($HTTP_GET_VARS['error']));
		}else{
			$error_message = MODULE_PAYMENT_ASJPAYMENT_TEXT_ERROR_MESSAGE;
		}
		return array('title' => MODULE_PAYMENT_ASJPAYMENT_TEXT_ERROR,
					 'error' => $error_message);
	}

	function check() {
		global $db;

		if (!isset($this->_check)) {
			$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ASJPAYMENT_STATUS'");
			$this->_check = $check_query->RecordCount();
		}
		return $this->_check;
	}

	function install() {
		global $db;

		$db->Execute("create table if not exists asjpayment_charge(n_charge int auto_increment primary key, n_admin int, n_amount int, c_mail varchar(96), d_create datetime)");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('ASJペイメントの使用', 'MODULE_PAYMENT_ASJPAYMENT_STATUS', 'True', 'ASJペイメントクレジットカード決済を有効にしますか?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ASJペイメント Url', 'MODULE_PAYMENT_ASJPAYMENT_URL', 'https://www.asjpayment.jp/cgi-bin/ps_payment.cgi', '決済情報送信先URL', '6', '0', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('契約者番号', 'MODULE_PAYMENT_ASJPAYMENT_ADMIN_NO', '', 'ASJペイメント契約者番号を入力してください', '6', '0', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Job Code', 'MODULE_PAYMENT_ASJPAYMENT_JOB_CODE', 'AUTH', 'ジョブコード', '6', '0', 'zen_cfg_select_option(array(\'CHECK\', \'CAPTURE\', \'AUTH\', \'SAUTH\'), ', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('結果通知', 'MODULE_PAYMENT_ASJPAYMENT_RET', 'OFF', '結果通知を行うか選択してください', '6', '5', 'zen_cfg_select_option(array(\'ON\', \'OFF\'), ', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('表示の順番', 'MODULE_PAYMENT_ASJPAYMENT_SORT_ORDER', '0', '表示の順番を設定します。数値順に表示されます', '6', '0', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_ASJPAYMENT_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('オーダーステータス', 'MODULE_PAYMENT_ASJPAYMENT_ORDER_STATUS_ID', '0', 'クレジットカード決済成功時のオーダーステータスを設定してください', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
	}

	function remove() {
		global $db;

		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE_PAYMENT_ASJPAYMENT%'");
	}

	function keys() {
		return array('MODULE_PAYMENT_ASJPAYMENT_URL', 'MODULE_PAYMENT_ASJPAYMENT_ADMIN_NO', 'MODULE_PAYMENT_ASJPAYMENT_SORT_ORDER');
	}
}
?>
